part of xwidgetbase;

class XElencoItem extends StatefulWidget {
  XElencoItem({
    Key? key,
    this.childMain,
    this.childDetails,
    this.showingDetails = false,
    this.showMainWithDetails = true,
    this.decorationBackGroundContainer,
    this.changeStatoWithTap = true,
    this.onTapItem,
    this.onLongTapItem,
    this.onDoubleTapItem,
    this.margin,
    this.crossAxisAlignment,
    this.backGroundColor_ChildMain,
    this.backGroundColor_ChildDetails,
    this.iconColor_Collapsed,
    this.iconColor_Expanded,
    this.showTrailingArrow = true,
    this.icon_Active,
    this.icon_Disabled,
    this.height_Icon,
    this.size_Icon,
    this.width_Icon,
    this.childMain_CrossAxisAlignment,
    this.widgets_LeftArea,
  }) : super(key: key);

  /// default TRUE
  bool showMainWithDetails;
  Widget? childMain;
  bool showingDetails;
  Widget? childDetails;
  List<Widget>? widgets_LeftArea;
  bool changeStatoWithTap;
  bool? showTrailingArrow;
  Color? backGroundColor_ChildMain;
  Color? backGroundColor_ChildDetails;
  Color? iconColor_Expanded;
  Color? iconColor_Collapsed;
  double? width_Icon;
  double? height_Icon;
  double? size_Icon;
  Decoration? decorationBackGroundContainer;
  EdgeInsetsGeometry? margin;
  CrossAxisAlignment? crossAxisAlignment;
  CrossAxisAlignment? childMain_CrossAxisAlignment;
  IconData? icon_Active;
  IconData? icon_Disabled;
  Function()? onTapItem;
  Function()? onLongTapItem;
  Function()? onDoubleTapItem;
  @override
  _XElencoItemState createState() => _XElencoItemState();
}

class _XElencoItemState extends State<XElencoItem> {
  Widget xBuilder_childMain() {
    return widget.childMain ?? Container();
  }

  @override
  Widget build(BuildContext context) {
    return Container(
        decoration: widget.decorationBackGroundContainer ?? BoxDecoration(),
        margin: widget.margin ?? EdgeInsets.only(bottom: 2),
        child: Column(crossAxisAlignment: widget.crossAxisAlignment ?? CrossAxisAlignment.center, children: [
          (widget.showMainWithDetails == false && widget.showingDetails == true)
              ? Container()
              : Container(
                  padding: widget.widgets_LeftArea != null ? null : EdgeInsets.all(5),
                  color: widget.backGroundColor_ChildMain,
                  child: Row(crossAxisAlignment: widget.childMain_CrossAxisAlignment ?? CrossAxisAlignment.center, children: [
                    (widget.widgets_LeftArea != null) ? Row(mainAxisSize: MainAxisSize.min, children: widget.widgets_LeftArea ?? []) : Container(width: 0, height: 0),
                    Expanded(
                      child: GestureDetector(
                          onTap: widget.changeStatoWithTap
                              ? widget.onTapItem ??
                                  () {
                                    setState(() => widget.showingDetails = !widget.showingDetails);
                                  }
                              : null,
                          onLongPress: widget.onLongTapItem ?? () {},
                          onDoubleTap: widget.onDoubleTapItem ?? () {},
                          child: Container(
                              padding: EdgeInsets.symmetric(vertical: 8),
                              child: Row(
                                children: [
                                  Expanded(child: xBuilder_childMain()),
                                  (widget.changeStatoWithTap == true && widget.showTrailingArrow == true)
                                      ? Container(
                                          alignment: Alignment.center,
                                          // margin: EdgeInsets.only(top: 10),
                                          padding: EdgeInsets.all(1),
                                          width: widget.width_Icon ?? 40,
                                          height: widget.height_Icon ?? 40,
                                          child: Icon(
                                            widget.showingDetails ? widget.icon_Active ?? Icons.keyboard_arrow_up_outlined : widget.icon_Disabled ?? widget.icon_Active ?? Icons.keyboard_arrow_down_outlined,
                                            color: (widget.showingDetails == false) ? widget.iconColor_Collapsed ?? Colors.grey : widget.iconColor_Expanded ?? Colors.yellow,
                                            size: widget.size_Icon ?? 28,
                                          ))
                                      : Container(width: 0, height: 0)
                                ],
                              ))),
                    )
                  ])),
          Container(
            color: widget.backGroundColor_ChildMain ?? widget.backGroundColor_ChildDetails,
            child: (widget.showingDetails ? widget.childDetails! : Container()),
          ),
        ]));
  }
}
